// CRx20 jcv 21-Sep-10 Added bti filtering per g/s id

#include "BTI.h"

#include "CalOalUtility.h"



///////////////////////
//
//
//
//
BTI::BTI() {

  // Load delays into memory
  DataSet *dataset = dataSetServer->open("bti.fit", Dal::Read);

  Table *tab = dataset->table("BTI");

  Column *startCol = tab->column("START");
  Column *endCol   = tab->column("END");
  // NEW CRx20
  Column *GSCol   = tab->column("GSID");

  ColumnData *startColD = startCol->data();
  ColumnData *endColD   = endCol->data();
  // NEW CRx20
  ColumnData *GSColD = GSCol->data();
  int16 *iGSid = GSColD->int16Data();
  // END CRx20

  for (unsigned int i = 0; i < tab->rows(); i++) {

    STime startTime(CalOalUtility::stringColumnRow(startColD, i));
    STime endTime(CalOalUtility::stringColumnRow(endColD, i));
    
    BTI_pair entry(startTime, endTime);

    timeFilter.push_back(entry);
    
    // NEW CRx20
    bti_gsid_Filter.push_back(iGSid[i]); 
    // END CRx20

  }

  dataSetServer->close(dataset);
  
}



