// CRx12  jcv           Refactoring the DU processing
// CRx14  jcv           Infrastructure for tmproc dumper/fixer 
// CRx15  jcv           filtering capabilities
// SPRx16 jcv 19-May-09 DFH guessing capabilities

#ifndef DUEXTRACTOR_H
#define DUEXTRACTOR_H

#include <string>
#include <utility>

#include "STime.h"

#include "ProcessorList.h"
#include "DUProcessor.h"
#include "DataFiles.h"

// NEW SPRx16
#include "dfhtimestamp.h"
// END SPR x16

class DUExtractor {
  
 public:
  
  void         registerProcessor(DUProcessor *proc); 
  void         unregisterProcessor(DUProcessor *proc);   

  // NEW CRx12
  //virtual void processDU();	
  // NEw CRx13
  virtual void processDU(FILE * rawFile, int *maxDU, bool *loop, bool bRunStrict);
  // NEW CRx14
  virtual void dumpDU(FILE * rawFile, FILE * outFile, int *maxDU, bool bRunStrict);

  virtual void loopDU();	
               DUExtractor(STime start, STime stop);
  virtual      ~DUExtractor() {delete tmArchive;};

 private:

  // NEW CRx12 Refactored DU Processing
  void fetchDU();
  // NEW CRx13
  //void processDU(FILE * rawFile, int *maxDU, bool *loop, bool bRunStrict);
   
  // Fields
  ProcessorList	Listeners[DUProcessor::nTypes];		
  
  unsigned int 	lastSequenceCount;
  STime		lastDUTime;

  STime		startTime;
  STime		stopTime;

  FILE *	currentFile;
  
  DataFiles     *tmArchive;

  bool          hasTimeFilter;

  // NEW CRx15
  struct FilterInfo AppliedFilterInfo;
  bool bAppliedFilter;
  // END CRx15

  // NEW SPRx16
  /* Array to hold list packets without a timestamp in the data field header */
  VTMZZ_TNODFHTIME   arNoDFHTime[ VTMZZ_MAX_NO_DFH_TIME_PACKETS ];
  /* Number "generic" packets without a timestamp in the data field header */
  int                iNumGeneric;
  /* Number "specific" packets without a timestamp in the data field header */
  int                iNumSpecific;
  // END SPRx16


};	

#endif
