// CRx14                  Infrastructure for dump/fixer
// CRx15                  Filtering capabilities
// SPRx16   jcv 20-May-09 DFH guessing capabilities

#ifndef DUPROCESSOR_H
#define DUPROCESSOR_H

#include "ProcessorList.h"
#include "Processor.h"
#include "DataDefinition.h"
#include "Processor.h"

// CRx15
#include "FilterDefinition.h"

// SPRx16
#include "dfhtimestamp.h"

class DUProcessor : public Processor {

 public: 
  
  enum type {ALL = 0, TM = 1, TC = 3, MOUT = 4, MOUTP = 5, TLEX = 6, TCORR = 7, nTypes = 8};
  
  void                       registerProcessor(Processor *proc); 
  void                       unregisterProcessor(Processor *proc); 
  procMap                    getMap();
  virtual void		     extractData(RawTM::XMCS::DataUnit *DU) = 0;
  // CRx14
  // CRx15
  //virtual void		     procData(RawTM::XMCS::DataUnit *DU) = 0;
  // SPRx16
  //virtual void    procData(RawTM::XMCS::DataUnit *DU, FilterInfo *Filters) = 0;
  virtual void    procData(RawTM::XMCS::DataUnit *DU, 
                           FilterInfo *Filters,
                           int iNumGeneric, int iNumSpecific,
                           VTMZZ_TNODFHTIME *MyarNoDFHTime ) = 0;

  virtual DUProcessor::type  processorType() = 0;
  virtual                    ~DUProcessor() {};
  
 private:
  
  ProcessorList	Listeners;
  
};

#endif
