// CRx15
// SPRx16 jcv 20-May-09 DFH Guessing capabilities

#ifndef PACKETPROCESSOR_H
#define PACKETPROCESSOR_H

#include "ProcessorList.h"
#include "Processor.h"
#include "DataDefinition.h"
#include "PacketConsumer.h"

// CRx15
#include "FilterDefinition.h"

// SPRx16 
#include "dfhtimestamp.h"


class PacketProcessor : public Processor {
  
 public: 
  RawTM::XMM::Packet       xmmPkt;
  RawTM::NCTRS::TMDU      *xmmFrame;

  // CRx15
  //virtual void processPacket(RawTM::NCTRS::TMDU *frame, RawTM::XMM::Packet &pkt, STime &time);
  // SPRx16
  //virtual void processPacket(FilterInfo *Filters, RawTM::XMM::Packet &pkt, STime &time);
  virtual void processPacket(FilterInfo *Filters, 
                             int iNumGeneric, int iNumSpecific,
                             VTMZZ_TNODFHTIME *MyarNoDFHTime,
                             RawTM::XMM::Packet &pkt, STime &time);
  
                          PacketProcessor(PacketConsumer *proc);
  virtual                 ~PacketProcessor() {};
  
 private:

  PacketConsumer         *dataProc;

  unsigned int           lastSTSP;
  bool                   haveSTSP;

  // SPR x16 DFH guessing capabilities
  //bool    hasTimeinDFH(unsigned int APID, unsigned short PacketType, unsigned short PacketSubtype);
  bool                   hasTimeinDFH(unsigned int APID, 
                                      unsigned short PacketType, 
                                      unsigned short PacketSubtype,
                                      int iNumSpecific, int iNumGeneric,
                                       VTMZZ_TNODFHTIME *MyarNoDFHTime);

  

};

#endif
