// CRx17 jcv 20-May-09 Original 

#ifndef TMFRAMESTREAM_H
#define TMFRAMESTREAM_H

#include "DUProcessor.h"
#include "DataDefinition.h"
#include "Utils.h"
#include "FrameConsumer.h"

#include "FilterDefinition.h"

#include "Delay.h"

class TMFrameStream : public DUProcessor {

public:

  enum VC {VC0 = 0, VC7 = 7};
  RawTM::NCTRS::TMDU     nctrsDU;

  DUProcessor::type     processorType() { return DUProcessor::TM; }

  void     extractData(RawTM::XMCS::DataUnit *DU);
  // Just for reverse compatibility with abstract DUProcessor
  void     procData(RawTM::XMCS::DataUnit *DU,
                           FilterInfo *Filters,
                           int iNumGeneric, int iNumSpecific,
                           VTMZZ_TNODFHTIME *MyarNoDFHTime );

           TMFrameStream();
          ~TMFrameStream() { }
  
 private:

  STime              correctFrameTime(Utils::CDSTime Time, unsigned short GSID);
  STime              calculatePacketTime(unsigned int iOffset, STime frameTime);
  FrameConsumer     *dataProc;
  TMFrameStream::VC channel;

  Delay              delayHandler;

  bool               isFirstFrame;
  bool               isOverspill;
  unsigned int       lastVC;
  unsigned int       iCopied;
  RawTM::XMM::Packet overspill;
  RawTM::XMM::Packet extractedPackets[ RawTM::NCTRS::max_packets ];
  STime              extractedPacketTimes[ RawTM::NCTRS::max_packets ];
  STime              overspillTime;  
  unsigned int       nPackets;

  // Reference point for XMCS correction
  STime refXMCSCorrection;

};

#endif
